require "import"
import "android.widget.*"
import "android.view.*"
import "android.app.*"
import "android.os.*"

activity.setTitle("رحلة البنزين الكبرى")

layout = {
  LinearLayout,
  orientation = "vertical",
  padding = "16dp",
  {
    TextView,
    id = "locationText",
    text = "الموقع: شارع الزيتون",
    textSize = "18sp",
  },
  {
    TextView,
    id = "descText",
    text = "شارع هادئ مليء بأشجار الزيتون والعصافير.",
    textSize = "14sp",
  },
  {
    TextView,
    id = "distanceText",
    text = "المتبقي: 2.5 كم",
    textSize = "14sp",
  },
  {
    Button,
    id = "walkButton",
    text = "اضغط واستمر للمشي",
    layout_marginTop = "10dp",
  },
  {
    TextView,
    id = "kmCounter",
    text = "عدد الكيلومترات: 0 كم",
    textSize = "16sp",
  },
  {
    TextView,
    id = "coinCounter",
    text = "العملات: 0",
    textSize = "16sp",
  },
  {
    TextView,
    id = "fuelLevel",
    text = "نسبة البنزين: 100%",
    textSize = "16sp",
  },
  {
    Button,
    id = "refuelButton",
    text = "تعبئة البنزين (10 عملات)",
    layout_marginTop = "10dp",
  },
  {
    TextView,
    id = "endText",
    text = "",
    visibility = View.GONE,
    textSize = "14sp",
    layout_marginTop = "16dp",
  },
  {
    Button,
    id = "exitButton",
    text = "خروج",
    visibility = View.GONE,
    layout_marginTop = "10dp",
  },
}

activity.setContentView(loadlayout(layout))

-- عدادات
km = 0
coins = 0
fuel = 100
distanceNeeded = 2.5
completed = false

-- تحديث الواجهة
function updateUI()
  kmCounter.setText("عدد الكيلومترات: " .. string.format("%.1f", km) .. " كم")
  coinCounter.setText("العملات: " .. coins)
  fuelLevel.setText("نسبة البنزين: " .. fuel .. "%")
  distanceText.setText("المتبقي: " .. string.format("%.1f", distanceNeeded) .. " كم")
end

-- مؤقت المشي
handler = Handler()
running = false

walkRunnable = Runnable{
  run = function()
    if running and fuel > 0 and distanceNeeded > 0 then
      km = km + 0.1
      coins = coins + 1
      fuel = fuel - 2
      distanceNeeded = distanceNeeded - 0.1
      if distanceNeeded <= 0 and not completed then
        distanceNeeded = 0
        completed = true
        Toast.makeText(activity, "مبروك! تم اجتياز الموقع!", 1).show()
        -- إظهار نهاية اللعبة
        endText.setVisibility(View.VISIBLE)
        endText.setText("حاليًا لا توجد مواقع أخرى.\nالنسخة تجريبية.\nتحياتي من تطوير أخوكم مهند التقني.")
        exitButton.setVisibility(View.VISIBLE)
      end
      updateUI()
      handler.postDelayed(walkRunnable, 300)
    elseif fuel <= 0 then
      Toast.makeText(activity, "نفد البنزين! عبّي أولاً", 1).show()
      running = false
    end
  end
}

-- لمس الزر
walkButton.setOnTouchListener{
  onTouch = function(v, event)
    if event.getAction() == MotionEvent.ACTION_DOWN then
      running = true
      handler.post(walkRunnable)
    elseif event.getAction() == MotionEvent.ACTION_UP then
      running = false
    end
    return true
  end
}

-- زر التعبئة
refuelButton.onClick = function()
  if coins >= 10 then
    coins = coins - 10
    fuel = 100
    updateUI()
  else
    Toast.makeText(activity, "لا تملك عملات كافية", 1).show()
  end
end

-- زر الخروج
exitButton.onClick = function()
  activity.finish()
end

updateUI()